
/*
------- CHANGELOG --------------------------------------------------------------
remember: `[check]'

	2007-09-15  Kim A. Brandt <kimabrandt@gmx.de>
	* 12291.user.js (youtube.com): Allow to watch YouTube videos and browse
	the `Related' list.

	2007-09-16  Kim A. Brandt <kimabrandt@gmx.de>
	* 12291.user.js (RELATED VIDEOS): Allow to browse the `Related Videos'
	list.

	2007-09-17  Kim A. Brandt <kimabrandt@gmx.de>
	* 12291.user.js (main): Added support for the sites `vids.myspace.com'
	and `video.google.com'.

	2007-09-19  Kim A. Brandt <kimabrandt@gmx.de>
	* 12291.user.js (main): Added support for the site `metacafe.com'.

	2007-09-29  Kim A. Brandt <kimabrandt@gmx.de>
	* 12291.user.js (main): Added support for the sites `veoh.com', `revver.com' and
	`brightcove.tv'.
	(metacafe_com): Show the recommended video-images.

	2007-09-29  Kim A. Brandt <kimabrandt@gmx.de>
	* 12291.user.js (function doFunc): Added the function `doFunc' with the
	parameters `(funcOnce, funcScript, nrOfScripts)' to reuse some code.
	`funcOnce' is a function which should be executed once. `funcScript'
	should be executed for every script element and `nrOfScripts' is the
	number of expected scripts.

------- COMMENTS ---------------------------------------------------------------

	<b>If you like JavaScript and are not worried about its use you won't
	need this script.</b>

	I am open for site suggestions. Tell me what functionality you would
	like to use on a site and I will see what I can/will do.
	  Actually I hope there is an interest in disabling JavaScript and to
	create/extend scripts to adjust site contents to our likings.
	  If you have some ideas or you know about a project which deals with
	this subject (no JavaScript and change site contents) let me know.
*/

function main()
{
	switch(window.location.host)
	{
		// BRIGHTCOVE.TV
		case "brightcove.tv":
		case "www.brightcove.tv": brightcove_tv(); break;

		// METACAFE.COM
		case "www.metacafe.com": metacafe_com(); break;

		// MYSPACE.COM
		case "vids.myspace.com": myspace_com(); break;

		// GOOGLE.COM
		case "video.google.com": google_com(); break;

		// REVVER.COM
		case "one.revver.com": revver_com(); break;

		// VEOH.COM
		case "www.veoh.com": veoh_com(); break;

		// YOUTUBE.COM
		case "youtube.com":
		case "www.youtube.com": youtube_com(); break;
	}
}

function brightcove_tv()
{
	var funcScript = function(script) {
		// SHOW FLASH-VIDEO
		if (script.search(/so\.addVariable\(\"initVideoId/) > -1)
		{
			var src = script.match(/var\ so.*/)[0].match(/http:\/\/[^\"]+/)[0];
			var id = script.match(/so\.addVariable\(\"initVideoId.*/)[0].match(/[0-9]+/)[0];
			$("flashcontent").innerHTML = "<embed flashvars=\"initVideoId=" + id + "&cdnURL=http://admin.brightcove.com&autoStart=false\" height=\"412\" quality=\"high\" src=\"" + src + "\" type=\"application/x-shockwave-flash\" width=\"486\"/>";
			count--;
		}
	};
	doFunc(null, funcScript, 1);
}

function metacafe_com()
{
	var funcOnce = function() {
		// SHOW IMAGES
		var images = document.evaluate(".//img[contains(@name, 'http://') and contains(@id, 'img-')]", document.body, null, XPathResult.UNORDERED_NODE_SNAPSHOT_TYPE, null);
		if (images) for (var i = 0; i < images.snapshotLength; i++)
		{
			var image = images.snapshotItem(i);
			var src = image.getAttribute("name");
			image.setAttribute("src", src);
		}

		// MOVE SIDE-BAR-SEARCHFORM
		if($("EmbedAndBookmarks")) $("EmbedAndBookmarks").appendChild($("SideBarSearchForm"));

		// SHOW SIDE-BAR-ITEM-CATALOG AND SIDE-BAR-SEARCH-FORM
		appendStyle(".SideBarItemCatalog, #SideBarSearchForm {display: block !important;} #SideBarSearchForm {margin: 0;}");

		// SET FAMILY-FILTER ON [check]
		createCookie("familyFilter", "0"); // EXPIRE AT END OF SESSION
	};
	var funcScript = function(script) {
		// SHOW FLASH-VIDEO
		if (script && script.search(/var\ so/) > -1)
		{
			var flashvars = script.match(/so\.addParam\(\"flashvars.*/)[0].match(/itemID=[^\"]+/)[0];
			var src = script.match(/var\ so.*/)[0].match(/http:\/\/[^\"]+/)[0];
			$("FlashObj").innerHTML = "<embed flashvars=\"" + flashvars + "\" height=\"100%\" quality=\"high\" src=\"" + src + "\" type=\"application/x-shockwave-flash\" width=\"100%\"/>";
			count--;
		}
	};
	doFunc(funcOnce, funcScript, 1);
}

function myspace_com()
{
	var funcScript = function(script) {
		// SHOW FLASH-VIDEO
		if (script.search(/var\ so/) > -1)
		{
			var flashvars = script.match(/var\ m.*/)[0].match(/[0-9]+/)[0];
			var src = script.match(/var\ s.*/)[0].match(/http:\/\/[^\"]+/)[0];
			$("videoPlayerComponent").innerHTML = "<embed flashvars=\"m=" + flashvars + "\" height=\"386\" quality=\"high\" src=\"" + src + "\" type=\"application/x-shockwave-flash\" width=\"480\"/>";
			count--;
		}
	};
	doFunc(null, funcScript, 1);
}

function google_com()
{
	var funcOnce = function() {
		// GENRE PAGE
		var tables = document.evaluate(".//table[contains(@style, 'visibility: hidden;')]", document.body, null, XPathResult.UNORDERED_NODE_SNAPSHOT_TYPE, null);
		if (tables) for (var i = 0; i < tables.snapshotLength; i++) tables.snapshotItem(i).setAttribute("style", "");

		// GOOGLE VIDEOS
		if ($("noscriptflash"))
		{
			$("3rdPartyFrame").parentNode.removeChild($("3rdPartyFrame"));
			appendStyle("#noscriptflash, #VideoPlayback {margin:0 !important; width:450px !important; height:370px !important;}");
		}
	};
	var funcScript = function(script) {
		// SHOW RELATED
		if ($("noscriptflash") && script.search(/function\ showRelated/) > -1)
		{
			// RELATED URL
			var url = "http://video.google.com/videorelated";
			var showRelated = script.match(/function\ showRelated[^}]+/)[0];
			var parameters = showRelated.match(/\+\ \"[^\"]+/g);
			for (var i = 0; i < parameters.length; i++) url += parameters[i].substring(3);

			// RELATED VIDEOS
			var thumbstrip = document.createElement("div");
			thumbstrip.setAttribute("class", "related_videos_thumbstrip_div");
			$("related-videos").innerHTML = "";
			$("related-videos").appendChild(thumbstrip);
			var doc = getResponseText(url);
			var lines = doc.match(/\-?[0-9]{19}.*/g);
			for (var i = 0; i< lines.length; i++)
			{
				var attributes = lines[i].split("	");
				var id = attributes[0];
				var src = attributes[1];
				var alt = attributes[2];
				var title = attributes[3];
				var href = attributes[7];
				thumbstrip.innerHTML += "<div class=\"related_video_thumb\"><center><table cellspacing=\"0\" cellpadding=\"0\"><tbody><tr><td valign=\"bottom\" height=\"62\" align=\"center\"><div id=\"favicon" + id + "\" style=\"border: 1px solid blue; position: relative; width: 80px; height: 60px; background-color: black;\"><a href=\"" + href + "\" rel=\"nofollow\"><img style=\"border: medium none ; width: 80px; height: 60px; margin-left: 0px; margin-top: 0px;\" title=\"" + title + "\" alt=\"" + alt + "\" src=\"" + src + "\"/></a></div></td></tr><tr><td valign=\"top\" align=\"center\"><div><a href=\"" + href + "\" rel=\"nofollow\" title=\"" + title + "\">" + alt + "</a></div></td></tr></tbody></table></center></div>";
			}
			count--;
		}
		// 3RD PARTY VIDEOS
		if (!$("noscriptflash") && script.search(/function\ init/) > -1)
		{
			var src = script.match(/ele\('3rdPartyFrame'\)\.src.*/)[0].match(/http:\/\/[^\"]+/)[0];
			src = src.replace(/\\u003d/ig, "=");
			window.location.replace(src);
			count--;
		}

	};
	doFunc(funcOnce, funcScript, 1);
}

function revver_com()
{
	var funcScript = function(script) {
		// SHOW FLASH-VIDEO
		if (script.search(/revverVideo\.embed/) > -1)
		{
			var id = script.match(/mediaId[^,]+/)[0].match(/[0-9]+/)[0];
			$("player_embed").innerHTML = "<object data=\"http://flash.revver.com/player/1.0/player.swf?r=rev_player-pd-" + id + "\" height=\"392\" type=\"application/x-shockwave-flash\" width=\"480\"><param name=\"flashvars\" value=\"mediaId=" + id + "\"/></object>\"";
			count--;
		}
	};
	doFunc(null, funcScript, 1);
}

function veoh_com()
{
	var funcScript = function(script) {
		// SHOW FLASH-VIDEO
		if (script.search(/AC_FL_RunContent/) > -1)
		{
			var src = script.match(/http:\/\/www\.veoh\.com[^\']+/)[0];
			$("videoPlayer").innerHTML = "<embed height=\"438\" quality=\"high\" src=\"" + src + "\" type=\"application/x-shockwave-flash\" width=\"540\"/>";
			count--;
		}
	};
	doFunc(null, funcScript, 1);
}

function youtube_com()
{
	var funcOnce = function() {
		// RELATED
		if ($("side_results")) eval($("side_results").getAttribute("onscroll"));

		// RELATED VIDEOS
		var images = document.evaluate(".//img[@class='vimg90' and @onload]", document.body, null, XPathResult.UNORDERED_NODE_SNAPSHOT_TYPE, null);
		if (images) for (var i = 0; i < images.snapshotLength; i++)
		{
			var img = images.snapshotItem(i);
			var onload = img.getAttribute("onload");
			img.src = onload.match(/http:\/\/[^\']+/)[0];
		}
	};
	var funcScript = function(script) {
		// SHOW FLASH-VIDEO
		if (script.search(/var\ swfArgs/) > -1)
		{
			var flashvars = script.match(/var\ swfArgs.*/)[0];
			flashvars = flashvars.substring(flashvars.indexOf("{")+1, flashvars.lastIndexOf("}")-1);
			flashvars = flashvars.replace(/:\'/g, "=").replace(/\',/g, "&");
			flashvars += "&playnext=0";
			var src = "/player2.swf?v=1";
			$("playerDiv").innerHTML = "<embed flashvars=\"" + flashvars + "\" height=\"370\" quality=\"high\" src=\"" + src + "\" type=\"application/x-shockwave-flash\" width=\"450\"/>";
			count--;
		}
	};
	doFunc(funcOnce, funcScript, 1);
}

function $(id) {return document.getElementById(id);}

function getScripts(){return document.evaluate(".//script/text()", document, null, XPathResult.UNORDERED_NODE_SNAPSHOT_TYPE, null);}

function appendStyle(css)
{
	var head = document.getElementsByTagName("head")[0];
	if (!head) return;
	var style = document.createElement("style");
	style.rel = "stylesheet";
	style.type = "text/css";
	style.innerHTML = css;
	head.appendChild(style);
}

var count = -1;
function doFunc(funcOnce, funcScript, nrOfScripts)
{
	count = nrOfScripts;
	if (funcOnce) try{
		funcOnce();
	}catch(e){dump(e+"\n");}
	if (funcScript) try{
		var scripts = getScripts();
		for(var i = 0; count > 0 && i < scripts.snapshotLength; i++) funcScript(scripts.snapshotItem(i).textContent);
	}catch(e){dump(e+"\n");}
}

function getResponseText(url)
{
	var request = new XMLHttpRequest();
	request.open("GET", url, false);
	request.send(null);
	if (request.status == 200) return request.responseText;
	return "";
}

function createCookie(name,value,days)
{
	if (days)
	{
		var date = new Date();
		date.setTime(date.getTime() + (days * 24 * 60 * 60 * 1000));
		var expires = "; expires=" + date.toGMTString();
	}
	else var expires = "";
	document.cookie = name + "=" + value + expires + "; path=/"; // CREATE COOKIE
}

/*function readCookie(name)
{
	var nameEQ = name + "=";
	var ca = document.cookie.split(";");
	for(var i = 0; i < ca.length; i++)
	{
		var c = ca[i];
		while (c.charAt(0) == " ") c = c.substring(1, c.length);
		if (c.indexOf(nameEQ) == 0) return c.substring(nameEQ.length, c.length);
	}
	return null;
}*/

/*function eraseCookies(name)
{
	var value = null;
	do
	{
		value = readCookie(name);
		createCookie(name, "", -1); // ERASE COOKIE
		name = value;
	} while (name);
}*/

main();
